"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withThemeManager = exports.useThemeManagerContext = exports.ThemeManagerProvider = exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var initState = {
  theme: {},
  // eslint-disable-next-line no-unused-vars
  setTheme: function setTheme(theme, callback) {}
};

var ThemeManagerContext = _react["default"].createContext(initState);

exports["default"] = ThemeManagerContext;

var ThemeManagerProvider =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(ThemeManagerProvider, _React$PureComponent);

  function ThemeManagerProvider(props) {
    var _this;

    _classCallCheck(this, ThemeManagerProvider);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(ThemeManagerProvider).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "setTheme", function (theme, callback) {
      _this.setState({
        theme: theme
      }, function () {
        if (callback && typeof callback === 'function') {
          callback(theme);
        }
      });
    });

    _this.state = {
      theme: props.initTheme || initState.theme
    };
    return _this;
  }

  _createClass(ThemeManagerProvider, [{
    key: "render",
    value: function render() {
      var children = this.props.children;
      var theme = this.state.theme;
      return _react["default"].createElement(ThemeManagerContext.Provider, {
        value: {
          theme: theme,
          setTheme: this.setTheme
        }
      }, children);
    }
  }]);

  return ThemeManagerProvider;
}(_react["default"].PureComponent);

exports.ThemeManagerProvider = ThemeManagerProvider;
ThemeManagerProvider.propTypes = {
  children: _propTypes["default"].any.isRequired,
  initTheme: _propTypes["default"].object
};
ThemeManagerProvider.defaultProps = {
  initTheme: {}
};

var useThemeManagerContext = function useThemeManagerContext() {
  return (0, _react.useContext)(ThemeManagerContext);
};

exports.useThemeManagerContext = useThemeManagerContext;

var withThemeManager = function withThemeManager(BaseComponent) {
  var WithThemeManager = function WithThemeManager(props) {
    return _react["default"].createElement(ThemeManagerContext.Consumer, null, function (ctx) {
      return _react["default"].createElement(BaseComponent, _extends({}, ctx, props));
    });
  };

  return WithThemeManager;
};

exports.withThemeManager = withThemeManager;