"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = deepCompareObj;
exports.sameArray = void 0;

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var sameArray = function sameArray(arr1, arr2) {
  return arr1.length === arr2.length && arr1.every(function (v) {
    return arr2.indexOf(v) > -1;
  });
};
/**
 * Deep Check if two object is same or not
 *
 * @param {*} obj1
 * @param {*} obj2
 */


exports.sameArray = sameArray;

function deepCompareObj(obj1, obj2) {
  if (_typeof(obj1) !== 'object' || _typeof(obj2) !== 'object') {
    return false;
  }

  var obj1Keys = Object.keys(obj1);
  var obj2Keys = Object.keys(obj2); // compare keys first

  if (!sameArray(obj1Keys, obj2Keys)) return false;
  return obj1Keys.every(function (key) {
    if (Array.isArray(obj1[key])) {
      if (!sameArray(obj1[key], obj2[key])) {
        return false;
      }
    } else if (_typeof(obj1[key]) === 'object') {
      return deepCompareObj(obj1[key], obj2[key]);
    } else if (obj1[key] !== obj2[key]) {
      return false;
    }

    return true;
  });
}