function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React, { useContext } from 'react';
import PropTypes from 'prop-types';
const initState = {
  theme: {},
  // eslint-disable-next-line no-unused-vars
  setTheme: (theme, callback) => {}
};
const ThemeManagerContext = React.createContext(initState);

class ThemeManagerProvider extends React.PureComponent {
  constructor(props) {
    super(props);

    _defineProperty(this, "setTheme", (theme, callback) => {
      this.setState({
        theme
      }, () => {
        if (callback && typeof callback === 'function') {
          callback(theme);
        }
      });
    });

    this.state = {
      theme: props.initTheme || initState.theme
    };
  }

  render() {
    const {
      children
    } = this.props;
    const {
      theme
    } = this.state;
    return React.createElement(ThemeManagerContext.Provider, {
      value: {
        theme,
        setTheme: this.setTheme
      }
    }, children);
  }

}

ThemeManagerProvider.propTypes = {
  children: PropTypes.any.isRequired,
  initTheme: PropTypes.object
};
ThemeManagerProvider.defaultProps = {
  initTheme: {}
};

const useThemeManagerContext = () => {
  return useContext(ThemeManagerContext);
};

const withThemeManager = BaseComponent => {
  const WithThemeManager = props => {
    return React.createElement(ThemeManagerContext.Consumer, null, ctx => {
      return React.createElement(BaseComponent, _extends({}, ctx, props));
    });
  };

  return WithThemeManager;
};

export { ThemeManagerContext as default, ThemeManagerProvider, useThemeManagerContext, withThemeManager };